---
title: 'ARIA: table role'
slug: Web/Accessibility/ARIA/Roles/Table_Role
tags:
  - ARIA
  - ARIA Role
  - ARIA Table
  - ARIA Table Role
  - Accessibility
  - Reference
  - Table Role
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p>The table value of the ARIA role attribute identifies the element containing the role as having a non-interactive table structure containing data arranged in rows and columns, similar to the native <a href="/en-US/docs/Web/HTML/Element/table"><code>&lt;table&gt;</code></a> HTML element.</p>

<pre class="brush: html">&lt;div role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;div id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/div&gt;
  &lt;div role="rowgroup"&gt;
    &lt;div role="row"&gt;
      &lt;span role="columnheader" aria-sort="none"&gt;ARIA Role&lt;/span&gt;
      &lt;span role="columnheader" aria-sort="none"&gt;Semantic Element&lt;/span&gt;
    &lt;/div&gt;
  &lt;/div&gt;
  &lt;div role="rowgroup"&gt;
    &lt;div role="row" aria-rowindex="11"&gt;
      &lt;span role="cell"&gt;header&lt;/span&gt;
      &lt;span role="cell"&gt;h1&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row" aria-rowindex="16"&gt;
      &lt;span role="cell"&gt;header&lt;/span&gt;
      &lt;span role="cell"&gt;h6&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row" aria-rowindex="18"&gt;
      &lt;span role="cell"&gt;rowgroup&lt;/span&gt;
      &lt;span role="cell"&gt;thead&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row" aria-rowindex="24"&gt;
      &lt;span role="cell"&gt;term&lt;/span&gt;
      &lt;span role="cell"&gt;dt&lt;/span&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<h2 id="Description">Description</h2>

<p>An element with role="table" is a static tabular structure with rows containing cells. The cells are not focusable or selectable, though widgets within individual cells of the table can be interactive. Using a native HTML table element whenever possible is strongly encouraged.</p>

<div class="warning">
<p>If a table maintains a selection state, has two-dimensional navigation, or allows the user to rearrange cell order use <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a> or <a href="/en-US/docs/">treegrid</a> instead.</p>
</div>

<p>To create an ARIA table, add <code>role="table"</code> to the container element. Within that container, each row has <code>role="row"</code> set and contains child cells. Each cell has a role of either <code>columnheader</code>, <code>rowheader</code>, or <code>cell</code>. Rows can be children of the table or within a <code>rowgroup</code>.</p>

<p>The table caption can be defined via aria-labelledby or aria-label.  All other semantic table elements, such as <code>&lt;tbody&gt;</code>, <code>&lt;thead&gt;</code>, <code>&lt;tr&gt;</code>, <code>&lt;th&gt;</code>, and <code>&lt;td&gt;</code> need to be added via associated roles, such as <code>rowgroup</code>, <code>row</code>, <code>columnheader</code>, and <code>cell</code>.</p>

<p>If the table contains sortable columns or rows, the <code>aria-sort</code> attribute should be added on the header cell element (not the table itself). If any rows or columns are hidden, the <code>aria-colcount</code> or <code>aria-rowcount</code> should be included indicating the total number of columns or rows, respectively, along with the <code>aria-colindex</code> or <code>aria-rowindex</code> on each cell. The <code>aria-colindex</code> or <code>aria-rowindex</code> is set to the position of a cell within the row or column, respectively. If the table includes cells that span multiple rows or multiple columns, then <code>aria-rowspan</code> or <code>aria-colspan</code> should be included as well. Realize, it is much simpler to use the <code><a href="/en-US/docs/Web/HTML/Element/table">&lt;table&gt;</a></code> element, along with all the related semantic elements and attributes that are all supported by all assistive technologies.</p>

<p>To create an interactive widget that has a tabular structure, use the grid pattern instead. If the interaction provides for the selection state of individual cells, if left to right and top to bottom navigation is provided, or if the user interface allows the rearranging of cell order or otherwise changing individual cell order such as through drag and drop, use <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a> or <a href="/en-US/docs/">treegrid</a> instead.</p>

<div class="note">
<p>Note: Using a native HTML table element whenever possible is strongly encouraged.</p>
</div>

<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<dl>
 <dt>role="rowgroup"</dt>
 <dd>An optional child of the table, the row group encapsulates a group of rows, similar to thead, tbody, and tfoot.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Row_Role">role="row"</a></dt>
 <dd>A row within the table, and optionally within a rowgroup, that is a container for one or more cells, columnheaders, or rowheaders.</dd>
 <dt>aria-describedby attribute</dt>
 <dd>Takes as its value the id of the element that serves as a description for the table.</dd>
 <dt>aria-label attribute</dt>
 <dd>The aria-label provides an accessible name for the table.</dd>
 <dt>aria-colcount attribute</dt>
 <dd>
 <p>This attribute is only required if the columns are not present in the DOM all the time. It provides an explicit indication of the number of columns in the full table. Set the value to the total number of columns in the full table. If unknown, set <code>aria-colcount="-1"</code>.</p>
 </dd>
 <dt>aria-rowcount attribute</dt>
 <dd>This attribute is only required if the rows are not present in the DOM all the time, such as scrollable tables that reuse rows to minimize the number of DOM nodes. It provides an explicit indication of the number of rows in the full table. Set the value to the total number of rows in the full table. If unknown, set <code>aria-colcount="-1"</code>.</dd>
</dl>

<h3 id="Keyboard_interactions">Keyboard interactions</h3>

<p>None</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<p>None. For sortable columns, see the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_Role">columnheader</a> aria role.</p>

<div class="note">
<p><span class="ILfuVd yZ8quc">The first rule of ARIA use is if you can use a native feature with the semantics and behavior you require already built in, instead of re-purposing an element and <strong>adding</strong> an ARIA role, state or property to make it accessible, then do so. Employ the HTML &lt;table&gt; element instead of the ARIA role of table whenever possible.</span></p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: html">&lt;div role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;div id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/div&gt;
  &lt;div role="rowgroup"&gt;
     &lt;div role="row"&gt;
       &lt;span role="columnheader" aria-sort="none"&gt;ARIA Role&lt;/span&gt;
       &lt;span role="columnheader" aria-sort="none"&gt;Semantic Element&lt;/span&gt;
     &lt;/div&gt;
   &lt;/div&gt;
   &lt;div role="rowgroup"&gt;
    &lt;div role="row" aria-rowindex="11"&gt;
       &lt;span role="cell"&gt;header&lt;/span&gt;
       &lt;span role="cell"&gt;h1&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="16"&gt;
      &lt;span role="cell"&gt;header&lt;/span&gt;
      &lt;span role="cell"&gt;h6&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="18"&gt;
      &lt;span role="cell"&gt;rowgroup&lt;/span&gt;
      &lt;span role="cell"&gt;thead&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="24"&gt;
      &lt;span role="cell"&gt;term&lt;/span&gt;
      &lt;span role="cell"&gt;dt&lt;/span&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<p>The above is part of a table. While the full table has 81 entries, as indicated by the <code>aria-rowcount </code>property, only four are currently visible. The columns are sortable, but not currently sorted, as indicated by the aria-sort property on the column headers.</p>

<h2 id="Best_practices">Best practices</h2>

<p>Only use table, tbody, thead, tr, th, td, etc., for data table structure. You can add these ARIA roles to ensure accessibility should the native semantics of the table be removed, such as with CSS. A relevant use case for the ARIA table role is when CSS's display property overrides the native semantics of a table, such as by <code>display: grid</code>. In this case, you can use the ARIA table roles to re-add the semantics.</p>

<h3 id="Added_benefits">Added benefits</h3>

<p>none</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#table","ARIA Table Role")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#table","ARIA Table Role")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/HTML/Tables/Advanced">HTML table element</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">ARIA: grid role</a></li>
</ul>
